//======================================================================
//RUPUTER
//      Copyright (c) Bernard SERRES 1999. All rights reserved.
//  Universal Beat
//
// Modifications:
// 30 Nov 1999 TEW
//   FIXED for handling onHandPC time zone
//   Each record in the WORLD.INI is apparently 40 bytes and not 38 bytes.
//   I am not sure if this should also the case for the Ruputer.
//   Also, the currently selected home city time record has its third byte
//   value set to 1, while the currently select visiting city time record
//   has its third byte value set to 2.
//======================================================================

 
#include "lcdbios.h"
#include "rupsys.h" 

int mm, mi, d, hl, hb, s;
long y;
char strbuf[32];
double sec;
int p,e;

static int decal[25] = {12,13,14,15,15,15,16,17,18,19,20,23,0,1,2,3,4,5,6,7,7,8,9,10,11};

void putstr(int x, int y, char *cp ,int f, int t)
{
  while (*cp) {
    gv_kput(x, y,cp,f,1,0);
    cp++;
    x += t;
  }
}

void long2str(char *cp, long value, int keta) 
{
  int x = keta;

  *(cp + x--) = 0;

  *(cp + x--) = value % 10 + '0';
  value /= 10;

  for (;x >= 0; x--) {
    if (value == 0) {
      *(cp + x) = ' ';
    } else {
      *(cp + x) = value % 10 + '0';
      value /= 10;
    }
  }
}

void display()
{
	long sec;
	hl = pSystemCtl->CPUram->NOW_Hour;
	mi = pSystemCtl->CPUram->NOW_Min;
	s = pSystemCtl->CPUram->NOW_Sec; 

  if ((hl - decal[p]) > 0)
    hb = hl - decal[p] - e;
  else
    hb = hl - decal[p] + 24 - e;

	strbuf[0] = pSystemCtl->CPUram->NOW_Hour / 10 % 10 + '0';
	strbuf[1] = pSystemCtl->CPUram->NOW_Hour % 10 + '0';
	strbuf[2] = ':';
	strbuf[3] = pSystemCtl->CPUram->NOW_Min / 10 + '0';
	strbuf[4] = pSystemCtl->CPUram->NOW_Min % 10 + '0';
	strbuf[5] = ':';
	strbuf[6] = pSystemCtl->CPUram->NOW_Sec / 10 + '0';
	strbuf[7] = pSystemCtl->CPUram->NOW_Sec % 10 + '0';
	strbuf[8] = 0;
	lcdfreeze(1);
	putstr(55, 2, strbuf,16,6);

	sec = hb*3600L + mi*60L + s;
	sec<<5;
	sec = sec / 86.4; 
	sec>>5; 

	long2str(strbuf, sec, 3);
	putstr(36, 25, strbuf,58,14);
	lcdfreeze(0);
}

void init()
{
	screen(1);
	cls(4);
	display();
	strbuf[0] = pSystemCtl->CPUram->NOW_Year / 10 % 10 + '0';
	strbuf[1] = pSystemCtl->CPUram->NOW_Year % 10 + '0';
	strbuf[2] = '/';
	strbuf[3] = pSystemCtl->CPUram->NOW_Month / 10 + '0';
	strbuf[4] = pSystemCtl->CPUram->NOW_Month % 10 + '0';
	strbuf[5] = '/';
	strbuf[6] = pSystemCtl->CPUram->NOW_Day / 10 + '0';
	strbuf[7] = pSystemCtl->CPUram->NOW_Day % 10 + '0';
	strbuf[8] = 0;
	putstr(0,0, strbuf,0,6);

  gv_kput(29,28,"@",0,0,0);
	gv_kput(16,52,"-Universal Beat-",5,0,0);
}

// TEW: 30 Nov 1999
//   Added constant for each record size in WORLD.INI
#define WORLDREC_SIZE 40

int main(void)
{
  char pays[WORLDREC_SIZE];
	int fhnd;

  /* Locate time zone.  Apparently this time zone will be stored in a */
  /* variable p which is an offset into the decal array.              */
	fhnd = dos_fopen("b:\\system\\ini\\world.ini",0);
	if (fhnd < 0) {
		gv_kput(0,40,"World.ini ???",2,0,0);
		return;
	}
	dos_fseek(fhnd,0,0);

	p=0;
  dos_fread(fhnd,pays,WORLDREC_SIZE);
  while ((pays[2] != 1) && (p++ < 26))
    dos_fread(fhnd,pays,WORLDREC_SIZE);
	dos_fclose( fhnd );

  /* TEW: what is this code looking for? */
	fhnd = dos_fopen("b:\\system\\system.ini",0);
	if (fhnd < 0) {
		gv_kput(0,40,"System.ini ???",2,0,0);
		return;
	}
	dos_fseek(fhnd,0,0);
	dos_fread(fhnd,pays,38);
	dos_fread(fhnd,pays,38);
	e = pays[24]; /* e = 1 si heure d'ete sinon 0 (63eme octet de SYSTEM.INI) */
	dos_fclose( fhnd );

	pSystemCtl->EventManager->eventReq |= EVENT_SEC; 

	init();
	while (-1)
	{
  	int Key = 1, rst;
		Key = Keyin(Bkey_dw| Bkey_up|Bkey_lf| Bkey_rg, -1);
		rst = EventCall(Key);
		if (rst==-1) return;
	 	else
		if (rst==1)
		{
			rst = EventExec();
			if (rst==-1) return;
			init();
			pSystemCtl->EventManager->eventReq |= EVENT_SEC; 
		}
		if (Key & Bkey_D) break;
		display();
	}

	bi_clrbtn();
	lcdon(1);
	gv_place(0,0);
	cls(4);
	return 0;
}


